//+------------------------------------------------------------------+
//|RSX_Filter                                       CCIFilter vX.mq4 |
//|                                                                  |                                      
//|                                                      mod by Raff |   
//+------------------------------------------------------------------+
// mtf 2008fxtsd  ki 

#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 SlateGray
#property indicator_color2 Lime
#property indicator_color3 Blue  
#property indicator_color4 Tomato
#property indicator_color5 Red
#property indicator_color6 Magenta
#property indicator_color7 ForestGreen
#property indicator_color8 Yellow

#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 4
#property indicator_width5 4
#property indicator_width6 4
#property indicator_width7 4
#property indicator_width8 4
//#property  indicator_level1  0
#property indicator_level1  70
#property indicator_level2  50
#property indicator_level3  30

#property indicator_levelcolor DarkSlateGray


//---- input parameters
extern int    RSX_Period             = 14;
extern int    RSX_Price              = 0;
extern int    UpperTriggerLevel     =  70;
extern int    LowerTriggerLevel     =  30;
//extern int    CriticalLevel         = 250;
extern int    TimeFrame = 0;
extern string TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";

extern bool   ShowBARS             = false;
extern int    BarWidth             = 4;
extern int    LineWidth            = 4;

extern bool   Show_Dots            = true;

extern bool   ZeroCrossAlerts                = false;
extern bool   LevelCrossAlerts               = false;

//extern string CriticalLevelAlert    = "CCI Critical Level";
extern string ZeroCrossUpAlert          = "RSX Level 50 Cross Up; ";
extern string ZeroCrossDnAlert          = "RSX Level 50 Cross Dn; ";
extern string UpperTriggerBuyAlert  = "RSX Upper Trigger CrossUp; ";
extern string UpperTriggerSellAlert = "RSX Upper Trigger CrossDn; ";
extern string LowerTriggerBuyAlert  = "RSX Lower Trigger CrossUp; ";
extern string LowerTriggerSellAlert = "RSX Lower Trigger CrossDn; ";
extern int    MaxBarsToCount           = 1500;
extern string note_Price = "Price(C O1 H2 3L 4M 5T W6)";

//---- indicator buffers
double RSX[];
double UpBuffer1[];
double UpBuffer2[];
double DnBuffer1[];
double DnBuffer2[];
double DnArr[];
double UpArr[];
double RSX_Dot[];

extern int T3_Period       = 8;
extern double T3_Curvature = 0.618;

double t3Array[];
double RSXArray[];

double e1,e2,e3,e4,e5,e6;
double c1,c2,c3,c4;
double n,w1,w2,b2,b3;

extern   int     SSALag = 10;
extern   int     SSANumComps = 2;
extern   int     SSAPeriodNorm = 10;
extern   int     SSAN = 300;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   IndicatorBuffers(8);
   

   SetIndexStyle(0,DRAW_LINE,0,LineWidth);
   SetIndexStyle(1,DRAW_LINE,0,LineWidth);
   SetIndexStyle(2,DRAW_LINE,0,LineWidth);
   SetIndexStyle(3,DRAW_LINE,0,LineWidth);
   SetIndexStyle(4,DRAW_LINE,0,LineWidth);
   if (ShowBARS) 
   {
   SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,BarWidth);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,BarWidth);
   SetIndexStyle(4,DRAW_HISTOGRAM,0,BarWidth);
   }
   
   SetIndexEmptyValue(5,EMPTY_VALUE);
   SetIndexEmptyValue(6,EMPTY_VALUE);
   
   SetIndexStyle  (5,DRAW_ARROW);
   SetIndexArrow  (5,159);
   SetIndexBuffer (5,DnArr);
   SetIndexStyle  (6,DRAW_ARROW);
   SetIndexArrow  (6,159);
   SetIndexBuffer (6,UpArr);
   
   SetIndexEmptyValue(7,EMPTY_VALUE);
   SetIndexArrow(7,158);     //159 115
   SetIndexStyle(7,DRAW_NONE);
   if(Show_Dots && !ShowBARS)     
   SetIndexStyle(7,DRAW_ARROW);

   

   SetIndexBuffer(0,RSX);
   SetIndexBuffer(1,UpBuffer1);
   SetIndexBuffer(2,UpBuffer2);
   SetIndexBuffer(3,DnBuffer1);
   SetIndexBuffer(4,DnBuffer2);
   SetIndexBuffer(5,DnArr);
   SetIndexBuffer(6,UpArr);
   SetIndexBuffer(7,RSX_Dot);
   
    
   SetIndexBuffer(8,t3Array);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
      
      TimeFrame= MathMax(TimeFrame,Period());

      switch(TimeFrame)
     {
      case 1 : string TimeFrameStr= "M1";  break;
      case 5 : TimeFrameStr=        "M5";  break;
      case 15 : TimeFrameStr=       "M15"; break;
      case 30 : TimeFrameStr=       "M30"; break;
      case 60 : TimeFrameStr=       "H1";  break;
      case 240 : TimeFrameStr=      "H4";  break;
      case 1440 : TimeFrameStr=     "D1";  break;
      case 10080 : TimeFrameStr=    "W1";  break;
      case 43200 : TimeFrameStr=    "MN1"; break;
      default : TimeFrameStr= "TF0";
     }

   string short_name;
   short_name="RSX Filter ("+RSX_Period+") ["+TimeFrameStr+"] L("+UpperTriggerLevel+", "+LowerTriggerLevel+")";
   IndicatorShortName(short_name);
   
   SetIndexLabel(0,"RSX ("+RSX_Period+")["+TimeFrameStr+"]");
   SetIndexLabel(1,"UpTrend");
   SetIndexLabel(2,"Mild UpTrend");
   SetIndexLabel(3,"Mild DownTrend");
   SetIndexLabel(4,"DownTrend");
   SetIndexLabel(5,"RSX ("+RSX_Period+")["+TimeFrameStr+"]Dn");
   SetIndexLabel(6,"RSX ("+RSX_Period+")["+TimeFrameStr+"]Up");

   SetIndexLabel(8,"T3 "+T3_Period);  
   
   SetIndexDrawBegin(0,RSX_Period);
   SetIndexDrawBegin(1,RSX_Period);
   SetIndexDrawBegin(2,RSX_Period);
   SetIndexDrawBegin(3,RSX_Period);  
   SetIndexDrawBegin(4,RSX_Period);
   SetIndexDrawBegin(5,RSX_Period);  
   SetIndexDrawBegin(6,RSX_Period);
   SetIndexDrawBegin(7,RSX_Period);  
   
   
   //---- variable reset

   e1=0; e2=0; e3=0; e4=0; e5=0; e6=0;
   c1=0; c2=0; c3=0; c4=0;
   n=0;
   w1=0; w2=0;
   b2=0; b3=0;

   b2=T3_Curvature*T3_Curvature;
   b3=b2*T3_Curvature;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+T3_Curvature+b3);
   c4=(1+3*T3_Curvature+b3+3*b2);
   n=T3_Period;

   if (n<1) n=1;
   n = 1 + 0.5*(n-1);
   w1 = 2 / (n + 1);
   w2 = 1 - w1;
   
  

   SetIndexDrawBegin(8,RSX_Period);  //t3

   return(0);
  }

//+------------------------------------------------------------------+
//| CCIFilter                                                        |
//+------------------------------------------------------------------+
int start()
  {
   int shift,trend;
   datetime TimeArray[];
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 

   
   double CCI0, CCI1;
   double UpDnZero, UpDnBuffer;
   

   int    limit,y, counted_bars=IndicatorCounted();
   limit= Bars-counted_bars;
   limit= MathMax(limit,TimeFrame/Period());
   limit= MathMin(limit,MaxBarsToCount);

   for(shift=0,y=0;shift<limit;shift++)
   {
   if (Time[shift]<TimeArray[y]) y++;

     RSX_Dot[shift]  =EMPTY_VALUE;
     DnArr[shift]    =EMPTY_VALUE;
     UpArr[shift]    =EMPTY_VALUE;
  	  RSX[shift]      =EMPTY_VALUE;
  	  
	  CCI0=iCustom(NULL,TimeFrame,"RSX",RSX_Period,RSX_Price,y);
	  CCI1=iCustom(NULL,TimeFrame,"RSX",RSX_Period,RSX_Price,y+1);
     //CCI0 = iCustom(NULL, 0, "#4X 2011 XARD SSA",SSALag,SSANumComps, SSAPeriodNorm,SSAN, 0, 0);
     //CCI1 = iCustom(NULL, 0, "#4X 2011 XARD SSA",SSALag,SSANumComps, SSAPeriodNorm,SSAN, 0, 1);
	  
  	  
  	  if(Time[shift]==TimeArray[y])
  	  {
  	  RSX_Dot[shift]=iCustom(NULL,TimeFrame,"RSX",RSX_Period,RSX_Price,y);
     
     if  (ShowBARS) RSX_Dot[shift]=0;
     }
  	 
  	  UpDnZero=0; UpDnBuffer=1;
     if (!ShowBARS) {UpDnZero=EMPTY_VALUE; UpDnBuffer=CCI0; RSX[shift]=CCI0;}
  	 
  	  UpBuffer1[shift]=UpDnZero;
  	  UpBuffer2[shift]=UpDnZero;
  	  DnBuffer1[shift]=UpDnZero;
  	  DnBuffer2[shift]=UpDnZero;

	  if (CCI0>UpperTriggerLevel)  UpBuffer1[shift]=UpDnBuffer;
	  if (CCI0>50 && CCI0<=UpperTriggerLevel) UpBuffer2[shift]=UpDnBuffer;
	  if (CCI0<50 && CCI0>=LowerTriggerLevel) DnBuffer1[shift]=UpDnBuffer;
	  if (CCI0<LowerTriggerLevel)  DnBuffer2[shift]=UpDnBuffer;

     if (CCI0>50 && CCI1<=50) {if(!ShowBARS) UpArr[shift]=50; if(shift==0 && ZeroCrossAlerts) Alerts(ZeroCrossUpAlert);}
     if (CCI0<50 && CCI1>=50) {if(!ShowBARS) DnArr[shift]=50; if(shift==0 && ZeroCrossAlerts) Alerts(ZeroCrossDnAlert);}
     if (CCI0>UpperTriggerLevel && CCI1<=UpperTriggerLevel) {if(!ShowBARS) UpArr[shift]=UpperTriggerLevel; if(shift==0 && LevelCrossAlerts) Alerts(UpperTriggerBuyAlert);}
     if (CCI0<UpperTriggerLevel && CCI1>=UpperTriggerLevel) {if(!ShowBARS) DnArr[shift]=UpperTriggerLevel; if(shift==0 && LevelCrossAlerts) Alerts(UpperTriggerSellAlert);}
     if (CCI0>LowerTriggerLevel && CCI1<=LowerTriggerLevel) {if(!ShowBARS) UpArr[shift]=LowerTriggerLevel; if(shift==0 && LevelCrossAlerts) Alerts(LowerTriggerBuyAlert);}
     if (CCI0<LowerTriggerLevel && CCI1>=LowerTriggerLevel) {if(!ShowBARS) DnArr[shift]=LowerTriggerLevel; if(shift==0 && LevelCrossAlerts) Alerts(LowerTriggerSellAlert);}
//     if (MathAbs(CCI0)>CriticalLevel && MathAbs(CCI1)<=CriticalLevel) {if(shift==0) Alerts(CriticalLevelAlert);}
//     if (MathAbs(CCI0)<CriticalLevel && MathAbs(CCI1)>=CriticalLevel) {if(shift==0) Alerts(CriticalLevelAlert);}
	}
	
	
      ///---- indicator calculation

      for(int i=limit; i>=0; i--)
      {
         RSXArray[i] = iCustom(NULL,0,"RSX",RSX_Period,PRICE_CLOSE,i);

         e1 = w1*RSXArray[i] + w2*e1;
         e2 = w1*e1 + w2*e2;
         e3 = w1*e2 + w2*e3;
         e4 = w1*e3 + w2*e4;
         e5 = w1*e4 + w2*e5;
         e6 = w1*e5 + w2*e6;

         t3Array[i]=c1*e6 + c2*e5 + c3*e4 + c4*e3;
       }
	return(0);	
 }

void Alerts(string AlertText)
  {

    static datetime timeprev;
    if(timeprev<iTime(NULL,0,0)) 
      {timeprev=iTime(NULL,0,0); 
         Alert( "RSX Filter ("+RSX_Period+") TF["+TimeFrame+"]"
         +UpperTriggerLevel+", "+LowerTriggerLevel+": ", AlertText,
         " ",Symbol(),", chart M",Period(),"  at  ", Close[0],"  -  ", TimeToStr(CurTime(),TIME_SECONDS));}
  }

